<script setup lang="ts">
import { RouterLink } from 'vue-router'
import type CartProduct from '@/models/CartProduct'
import { computed, ref, watch } from 'vue'
import { useCartStore } from '@/stores/cart'

const props = defineProps<{
  item: CartProduct
}>()

const store = useCartStore()

const { removeFromCart, incrementCount, decrementCount, setCount } = store

const price = computed<number>(() => {
  const price = props.item.selectedSize.price - props.item.selectedSize.price * (props.item.discount / 100)
  return +price.toFixed(0)
})



const count = ref(props.item.count)

const subtotalPrice = computed<number>(() => price.value * count.value)

watch(() => props.item.count, (value: number) => count.value = value)
watch(count, (value) => {
  if(!value) {
    setCount(props.item.selectedSize.id, 1)
    count.value = 1
  } else {
    setCount(props.item.selectedSize.id, value)
  }
})

function onIncrement(): void {
  incrementCount(props.item.selectedSize.id)
}

function onDecrement(): void {
  if (props.item.count > 1) {
    decrementCount(props.item.selectedSize.id)
  } else {
    removeFromCart(props.item.selectedSize.id)
  }
}

</script>
<template>
  <tr>
    <td class="product-remove">
      <a href="#" class="remove-wishlist" @click.stop.prevent="removeFromCart(item.selectedSize.id)"><i class="fal fa-times"></i></a>
    </td>
    <td class="product-thumbnail">
      <RouterLink :to="{ name: 'single-product', params: { category: item.category.slug, product: item.slug } }">
        <img :src="item.image" :alt="item.title">
      </RouterLink>
    </td>
    <td class="product-title">
      <RouterLink :to="{ name: 'single-product', params: { category: item.category.slug, product: item.slug } }">
        {{ item.title }}
      </RouterLink>
    </td>
    <td class="product-price" data-title="Price">
      <span class="currency-symbol">$</span>{{price}}
    </td>
    <td class="product-quantity" data-title="Qty">
      <div class="pro-qty">
        <span class="dec qtybtn" @click.prevent.stop="onDecrement">-</span>
        <input type="number" class="quantity-input" v-model="count">
        <span class="inc qtybtn" @click.prevent.stop="onIncrement">+</span>
      </div>
    </td>
    <td class="product-subtotal" data-title="Subtotal">
      <span class="currency-symbol">$</span>{{ subtotalPrice }}
    </td>
  </tr>
</template>
